/*
 *  $Id: l4_com.h,v 1.4 1996/06/17 15:45:47 baumgrtl Exp $
 */

#define COM1 0x03f8
#define COM2 0x02f8

#define COM_BASE COM2
                                        /* Receiver Buffer Register */
#define COM_RBR  COM_BASE + 0
                                        /* Transmitter Holding Register */
#define COM_THR  COM_BASE + 0
                                        /* Interrupt Enable Register */
#define COM_IER  COM_BASE + 1
                                        /* Interrupt Identification Register */
#define COM_IIR  COM_BASE + 2
                                        /* Line Control Register */
#define COM_LCR  COM_BASE + 3
                                        /* Modem Control Register */
#define COM_MCR  COM_BASE + 4
                                        /* Line Status Register */
#define COM_LSR  COM_BASE + 5
                                        /* Modem Status Register */
#define COM_MSR  COM_BASE + 6

#define COM_DLLO COM_BASE + 0
#define COM_DLHI COM_BASE + 1
                                        /* IRQ 3 = COM2 */
#define COM_IRQ 3

#define LSR_RCV_FULL  b00000001
#define LSR_TSR_EMPTY b01000000


#define BAUDRATE 115200
#define DIVISOR (115200 / BAUDRATE)
