.\"Warning: don't edit this file. It has been generated by typeset
.\" The next compilation will silently overwrite all changes.
.TH "l4_nchief" 1 "27.06.96" "Institut" "User Commands"
.SH NAME
 l4_nchief \-  deliver the thread id of the nearest partner of the invoker

.SH " Synopsis"
.nf
\fB#include <syscalls.h>\fP
.fi
.PP
\fBstatic inline int\fP 
.br
\fBl4_nchief(l4_threadid_t \fP\fIdest\fP , \fBl4_threadid_t \fP\fI*next_chief\fP\fB);\fP

.SH "Description"
The \fBl4_nchief()\fP system call delivers the id of the nearest partner
which would be engaged when sending a message to the specified destination.
.SH "Arguments"
.IP "\fIdest\fP"
Thread id of the destination.
.IP "\fI*next_chief\fP"
Pointer to thread id of the nearest partner,
depending on return value.
.SH "Return Values"
The following values determine the contents of the thread id,
next_chief is pointing to:
.IP "\fBL4_NC_SAME_CLAN\fP"
The destination resides in the same clan, its id is returned. 
.IP "\fBL4_NC_INNER_CLAN\fP"
The destination resides in an inner clan, whose chief is in the same
clan as the caller. The call returns the id of this chief.
.IP "\fBL4_NC_OUTER_CLAN\fP"
The destination is outside of the invoker's clan. It's own chief's id
is returned.
.SH "See Also"
 l4_thread_ex_regs ,  l4_fpage_unmap ,  l4_myself ,  l4_thread_switch ,  l4_thread_schedule ,  l4_task_new  
